﻿/*******************************************************************************
 * 蜂窝大战复刻版
 * -----------------------------------------------------------------------------
 * Conmajia '野比' <conmajia@gmail.com>
 * 5 JUL. 2012
 * All Rights Reserved
 * ****************************************************************************/
using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace HiveBattle
{
    public class DoubleBufferedGraphics
    {
        #region vars
        Graphics canvas;
        Bitmap memoryBmp;
        int width;
        int height;
        #endregion

        #region inits
        public DoubleBufferedGraphics()
        {
            canvas = null;
            memoryBmp = null;
            width = 0;
            height = 0;
        }
        #endregion

        #region props
        public bool CanDoubleBuffer
        {
            get { return canvas != null; }
        }

        public Graphics Graphics
        {
            get { return canvas; }
        }
        #endregion

        #region methods
        public bool Create(Graphics g, int width, int height)
        {
            // clean up
            if (memoryBmp != null)
            {
                memoryBmp.Dispose();
                memoryBmp = null;
            }
            if (canvas != null)
            {
                canvas.Dispose();
                canvas = null;
            }

            if (width < 1 || height < 1)
                return false;

            this.width = width;
            this.height = height;
            memoryBmp = new Bitmap(width, height);
            canvas = Graphics.FromImage(memoryBmp);

            canvas.Clear(Color.Black);
            return true;
        }

        public void Render(Graphics g)
        {
            if (memoryBmp != null)
                g.DrawImage(
                    memoryBmp,
                    0, 0,
                    width, height);
        }
        #endregion
    }
}
