﻿/*******************************************************************************
 * 蜂窝大战复刻版
 * -----------------------------------------------------------------------------
 * Conmajia '野比' <conmajia@gmail.com>
 * 5 JUL. 2012
 * All Rights Reserved
 * ****************************************************************************/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using System.Diagnostics;

namespace HiveBattle
{
    public partial class Form1 : Form
    {
        #region consts
        public const int DEF_EASY = 15;
        public const int DEF_NORMAL = 25;
        public const int DEF_HARD = 35;
        public const int DEF_EXPERT = 55;
        #endregion

        #region vars
        public static int size = DEF_NORMAL;
        public static ArrayList players = new ArrayList();

        public DoubleBufferedGraphics gr = new DoubleBufferedGraphics();
        public Board b;
        #endregion

        #region inits
        public Form1()
        {
            InitializeComponent();
        }
        #endregion

        #region form events
        private void InitiateGame(object sender, System.EventArgs e)
        {
            //New Game
            gr = new DoubleBufferedGraphics();
            gr.Create(Graphics.FromHwnd(panel1.Handle), panel1.Width, panel1.Height);
            b = new Board(size, (((int)((float)panel1.Height / 1.4f) / size) / 2) * 2, gr);
            b.cx = panel1.Width / 2 - ((b.grid * 3 / 2) * b.size / 2);
            b.cy = panel1.Height / 2 - (b.grid * b.size / 2);

            for (int t = 0; t < players.Count; t++)
            {
                Player tm = (Player)players[t];
                tm.Initiate((b.size * b.size) / 150);
            }

            b.Players = players;
            b.FillPlayers();
            b.DrawBoard();

            panel1.Refresh();
        }
        #endregion

        #region paint
        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            gr.Render(e.Graphics);

            if (!initiatialized)
            {
                StringFormat sf = new StringFormat();
                sf.Alignment = StringAlignment.Center;
                sf.LineAlignment = StringAlignment.Center;
                e.Graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
                e.Graphics.DrawString("请点击「新游戏」开始", panel1.Font, Brushes.White, panel1.ClientRectangle, sf);
            }
        }
        #endregion

        #region resize
        private void panel1_Resize(object sender, EventArgs e)
        {
            if (b != null)
            {
                b.grid = (((int)((float)panel1.Height / 1.4f) / size) / 2) * 2;
                b.grid2 = b.grid / 4;
                b.cx = panel1.Width / 2 - ((b.grid * 3 / 2) * b.size / 2);
                b.cy = panel1.Height / 2 - (b.grid * b.size / 2);

                gr.Create(Graphics.FromHwnd(panel1.Handle), panel1.Width, panel1.Height);

                b.DrawBoard();
            }

            Refresh();
        }
        #endregion

        #region mouse
        private void panel1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            if (b == null)
                return;

            if (b.picked == false)
            {
                Player cpu = (Player)b.Players[b.turn];
                //Get
                int x = b.Xind(e.X, e.Y);
                int y = b.Yind(e.X, e.Y);
                try
                {
                    if (b.board[x, y] == b.turn + 1)
                    {
                        b.board[x, y] = 0;
                        b.DrawBoard();
                        gr.Render(Graphics.FromHwnd(this.Handle));
                        b.picked = true;
                        panel1.Cursor = Cursors.SizeAll;
                    }
                }
                catch { Debug.WriteLine("Exception @ 120"); }
            }
            else
            {
                //Put
                int x = b.Xind(e.X, e.Y);
                int y = b.Yind(e.X, e.Y);
                if ((x >= 0) && (y >= 0) && (x < b.size) && (y < b.size))
                    if ((b.board[x, y] == 0) && (b.IsAround(x, y, b.turn + 1) > 0))
                    {
                        b.board[x, y] = b.turn + 1;
                        b.DrawBoard();
                        gr.Render(Graphics.FromHwnd(this.Handle));
                        b.picked = false;
                        panel1.Cursor = Cursors.Default;
                        b.moves--;
                        Debug.WriteLine("Moves " + b.moves);
                        if (b.moves <= 0)
                        {
                            while (true)
                            {
                                //Move Targets
                                Player t = (Player)b.Players[b.turn];
                                for (int g = 0; g < t.Target; g++)
                                {
                                    if (b.IsAround(t.x[g], t.y[g], 0) > 0)
                                    {
                                        Random r = new Random();
                                        for (int l = 0; l < 1000; l++)
                                        {
                                            int q = t.x[g];
                                            int w = t.y[g];
                                            int i = r.Next(6);
                                            if (i == 0) q--;
                                            if (i == 1) q++;
                                            if (i == 2) w--;
                                            if (i == 3) w++;
                                            if (t.x[g] % 2 == 0)
                                            {
                                                if (i == 4)
                                                {
                                                    q++;
                                                    w--;
                                                }
                                                if (i == 5)
                                                {
                                                    q--;
                                                    w--;
                                                }
                                            }
                                            else
                                            {
                                                if (i == 4)
                                                {
                                                    q++;
                                                    w++;
                                                }
                                                if (i == 5)
                                                {
                                                    q--;
                                                    w++;
                                                }
                                            }
                                            try
                                            {
                                                if (b.board[q, w] == 0)
                                                {
                                                    b.board[t.x[g], t.y[g]] = 0;
                                                    t.x[g] = q;
                                                    t.y[g] = w;
                                                    b.board[t.x[g], t.y[g]] = 1000;
                                                    //b.DrawBoard();
                                                    //gr.Render(Graphics.FromHwnd(panel1.Handle));
                                                    break;
                                                }
                                            }
                                            catch { Debug.WriteLine("Exception @ 196"); }
                                        }
                                    }
                                }

                                //Check for Winning condition
                                if (b.Cost(b.turn) == 0)
                                {
                                    MessageBox.Show(((Player)b.Players[b.turn]).Name + " 获胜...");
                                    InitiateGame(null, null);
                                    return;
                                }

                                //Next turn
                                b.moves = b.allowedmoves;
                                b.turn++;
                                if (b.turn >= b.Players.Count)
                                    b.turn = 0;

                                Debug.WriteLine("Turn " + b.turn);

                                b.DrawBoard();
                                gr.Render(Graphics.FromHwnd(panel1.Handle));

                                Player cpu = (Player)b.Players[b.turn];
                                if (cpu.IsCpu == true)
                                {
                                    //Computer Play
                                    while (b.moves > 0)
                                    {
                                        //Pick the worst piece
                                        double minscore = double.MaxValue;
                                        int minx = 0;
                                        int miny = 0;
                                        for (int w = 0; w < b.size; w++)
                                        {
                                            for (int q = 0; q < b.size; q++)
                                            {
                                                if (b.board[q, w] == b.turn + 1)
                                                {
                                                    b.board[q, w] = 0;
                                                    double cost = b.Cost(b.turn);
                                                    if (cost < minscore)
                                                    {
                                                        minscore = cost;
                                                        minx = q;
                                                        miny = w;
                                                    }
                                                    b.board[q, w] = b.turn + 1;
                                                }
                                            }
                                        }
                                        b.board[minx, miny] = 0;
                                        b.DrawBoard();
                                        gr.Render(Graphics.FromHwnd(panel1.Handle));
                                        //put it in the best place
                                        minscore = double.MaxValue;
                                        for (int w = 0; w < b.size; w++)
                                        {
                                            for (int q = 0; q < b.size; q++)
                                            {
                                                if ((b.board[q, w] == 0) && (b.IsAround(q, w, b.turn + 1) > 0))
                                                {
                                                    b.board[q, w] = b.turn + 1;
                                                    double cost = b.Cost(b.turn);
                                                    if (cost < minscore)
                                                    {
                                                        minscore = cost;
                                                        minx = q;
                                                        miny = w;
                                                    }
                                                    b.board[q, w] = 0;
                                                }
                                            }
                                        }
                                        b.board[minx, miny] = b.turn + 1;
                                        b.DrawBoard();
                                        gr.Render(Graphics.FromHwnd(panel1.Handle));
                                        b.moves--;
                                    }
                                }
                                else
                                    break;
                            }
                        }
                    }
            }
        }
        #endregion

        #region toolbar
        // new game
        bool initiatialized = false;
        private void toolStripButton1_Click(object sender, EventArgs e)
        {

            OptionsForm of = new OptionsForm();
            if (of.ShowDialog(this) == DialogResult.OK)
            {
                if (!initiatialized)
                {
                    //Player player = new Player();
                    //player.Name = "玩家";
                    //player.Color = Color.DodgerBlue;
                    //players.Add(player);
                    //player = new Player();
                    //player.Name = "电脑";
                    //player.IsCpu = true;
                    //player.Color = Color.Crimson;
                    //players.Add(player);
                    InitiateGame(null, null);

                    initiatialized = true;
                }

                InitiateGame(null, null);
            }
        }

        // options
        private void toolStripButton2_Click(object sender, EventArgs e)
        {
        }

        // help
        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            HelpForm hf = new HelpForm();
            hf.ShowDialog(this);
        }

        // about
        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            AboutForm af = new AboutForm();
            af.ShowDialog(this);
        }
        #endregion
    }
}